/***************************************************************
	Encoder.c 
	
								2015.7.17@M.Utsumi@ARCDEVICE

****************************************************************/
#include"MCD05.h"
#include"Encoder.h"

UN_COUNTER ENCODER_Counter;
volatile WORD EncCount;// GR[_̃JEglFԎ󂯓np
WORD count_o;

float k_pulse;	// pulse/duty
char ENCODER_SimMode = FALSE;


void ENCODER_Open( void )
{
	POSCNT = 0;
	MAXCNT = 0xFFFF;
	k_pulse=1.0f;

	ADPCFGbits.PCFG4 = 1;	// Enanle QEA
	ADPCFGbits.PCFG5 = 1;	// Enanle QEB
	
	QEICON = 0x0700; //0000 0111 0000 0000
	/* 
		15: CNTERR Flag
		14: N/A
		13: QEISEL = 0 Continue in idle mode
		12: INDEX pin status
		11: UPDN up/down
		10-8: QEIM = 111 x4 mode match
		7:  SWPAB = 0 noswap
		6:  PCDOOUT = 0 dir output disable
		5:  TQGATE = 0 Timer gate timer disable
		4-3: TQCKPS = 00 timer input prescale 1:1
		2:  POSRES = 0 Index reset disable
		1:  TQCS = 0 Internal time clock source
		0:  UDSRC =0 depend on UPDN
	*/
	DFLTCON = 0x0100;
	/*
		15-9: N/A
		8: CDID = 1 count error interrupt disable
		7: QEOUT = 0 QEA/QEB digital filter disable
		6-4: QECK 000 clock divide 1:1
		3: INDOUT = 0 INDEX digital filter disable
		2-0: INDCK 000 clock divide 1:1
	*/

	ENCODER_ClearCounter();

}

int ENCODER_GetRelativeCount(void)
{
	unsigned short count;
	int dif;

	count = EncCount;
				
	if( count_o > 0xEFFF && count <  0x0FFF ){ // Overflow
		ENCODER_Counter._16.count_L = count;
		ENCODER_Counter._16.count_H++;
		dif = (int)(count + (0xFFFF - count_o + 1));
	}else if( count_o < 0x0FFF && count > 0xEFFF   ){ //Underflow
		ENCODER_Counter._16.count_L = count;
		ENCODER_Counter._16.count_H--;
		dif = -(int)(( 0xFFFF - count + 1 ) + count_o );
	}else{
		ENCODER_Counter._16.count_L = count;
		dif = (int)(count - count_o);
	}

	count_o = count;

	return( dif );

}

void ENCODER_WriteCounter( long count )
{
	ENCODER_Counter.count_32 = count;
	POSCNT = ENCODER_Counter._16.count_L; 
	count_o = ENCODER_Counter._16.count_L;
	EncCount = POSCNT;
}

void ENCODER_ClearCounter( void )
{
	ENCODER_WriteCounter( 0 );
}

void ENCODER_SetSimMode( float rate )
{
	k_pulse = rate;
	ENCODER_SimMode = TRUE;
}

void ENCODER_ResetSimMode( void )
{
	ENCODER_SimMode = FALSE;
}

void ENCODER_SimCount( short duty )
{
	POSCNT += (short)(k_pulse * duty );
}
