/************************************************************
	MCD05 Control Program Ver 2.1

						2015.7.13	M.Ustumi@ARCDEVICE

*************************************************************/

#include"stdio.h"
#include"math.h"

#include"ControlModule.h"
#include"Encoder.h"
#include"MotorPWM.h"
#include"Ad.h"

// R}h
#define MCD05_CLEAR_DATA	51
#define MCD05_EXCHANGE		150

typedef struct _MCD05_INPUT_ENC
{
	long lEncoder;
//	WORD wSensor[5];
} MCD05_INPUT;

typedef struct _MCD05_OUTPUT_PWM
{
	short sPwm;
} MCD05_OUTPUT;

MCD05_INPUT InputData;
MCD05_OUTPUT OutputData;

/******************************************************************

 ^C}
 ̓^C}1ōC̊荞݂CM_ControlTrigTRUEɂD
 C䃋[`CM_ControlTrigTRUEɂȂ܂ő҂̏sD
CM_ControlTrig̓C䃋[`FALSEɂD

******************************************************************/

void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt( void )
{
	IFS0bits.T1IF = 0;
	UT_ControlTrig = TRUE;

	//if( CM_wCtrlTimeout > 0 ) CM_wCtrlTimeoutCount++;
	if( ESPI1_wTimeout > 0 ) ESPI1_wTimeoutCount++;

	ENCODER_Count();	// GR[_l莞Ԃŕۑ
}

void Control(void)
{
	ENCODER_GetRelativeCount(); // ΃JEg̎擾
	InputData.lEncoder = ENCODER_Counter.count_32; // 32bit΃JEgl
	CM_WriteBuf( (BYTE*)&InputData, sizeof( MCD05_INPUT ));

	CM_PrepareReply();
}

void ClearData( void )
{
	ENCODER_ClearCounter();
	CM_Reply();
}

void Init( void )
{
	TRIS_LED = 0; // output

	//AD_Open();
	ENCODER_Open();

	MOTOR_Open();
	OutputData.sPwm=0;
	
	CM_Init(); // ʐM@\,f[^obt@̏,^C}Jn
	Control(); // f[^̃vZbg
}

// R}h̏
void SyncCommandProc(void)
{
	BYTE bCommand;

	// obt@ɓǂݍ܂ꂽR}h̓ǂݏoƑM
	CM_ChangeRxBuffer();
	CM_ReadBuf( &bCommand, 1 );
	switch(bCommand){
	case CM_OPEN:		CM_Open(); break;
	case CM_CLOSE:		CM_Close();	break;
	case CM_RESET:		CM_Reset(); break;
	case CM_PING:		CM_Ping(); break;
	case CM_SET_ID: 	CM_SetID(); break;
	case CM_GET_ID:		CM_GetID(); break;
	case CM_GET_VER:	CM_GetVer(); break;
	case CM_BLINK:		CM_Blink(); break;
	case CM_SET_PARAM:	CM_SetParam(); break;
	case CM_GET_PARAM:	CM_GetParam(); break;
	case MCD05_CLEAR_DATA: 	ClearData(); break;
	default:
		CM_bStatus = CM_COMMAND_UNDEFINED;
		CM_Reply();
	}

	CM_Rearm();	// M̏
}

// 񓯊R}h
void AsyncCommandProc(void)
{
	BYTE bCommand;

	// obt@ɓǂݍ܂ꂽR}h̓ǂݏo

	CM_ChangeRxBuffer();
	CM_ReadBuf( &bCommand, 1 );

	switch( bCommand ){
	case MCD05_EXCHANGE:
		CM_ReadBuf( (BYTE*)&OutputData, sizeof(MCD05_OUTPUT) );
		MOTOR_Drive( 0, OutputData.sPwm );
		break;
	default: break;
	}
}

void ProcStatus( void )
{
	switch( CM_bStatus ){
	case CM_NORMAL: UT_StatusBlink(1000, 1, 1); break;
	case CM_COMMAND_UNDEFINED: UT_StatusBlink(250, 1, 3); break;
	case CM_COMMAND_RX_TIMEOUT: UT_StatusBlink(250, 2, 3 ); break;	
	case CM_COMMAND_SUM_ERROR: UT_StatusBlink(250, 3, 3 );  break;
	case CM_REPLY_TX_TIMEOUT: UT_StatusBlink(250, 4, 3 ); break;	
	case CM_REPLY_ERROR+ESPI_SCK_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_SCK_HUNGUP: UT_StatusBlink( 250, 5, 3); break;
	case CM_REPLY_ERROR+ESPI_CS_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_CS_HUNGUP: UT_StatusBlink( 250, 6, 3); break;
	}
}

int main(void)
{
	BOOL ControlON = FALSE;

	Init();
	UT_StatusBlink( 250, 2, 2 );

	while(1){

		if( CM_SyncCommandReady ){ // ^@ߎMóf[^M
			SyncCommandProc();
			Control(); // f[^̃vZbg
			CM_SyncCommandReady = FALSE;
			ControlON = FALSE;
			MOTOR_Free();

			UT_StatusBlink(25, 1, 2 );

		}else if( CM_AsyncCommandReady ){ // 񓯊^@ߎMf[^M@Ao
			AsyncCommandProc();
			CM_AsyncCommandReady = FALSE;
			ControlON = TRUE;
			UT_StatusBlink(25, 1, 2 );
		}

		if( UT_ControlTrig ){
			if( ControlON ) Control();

			ProcStatus();
			UT_ControlTrig = FALSE;
		}	
	}
}

